<?php

namespace Drupal\drupalmoduleupgrader;

use Drupal\Core\Plugin\PluginBase;

/**
 * Base class for analyzers.
 */
abstract class AnalyzerBase extends PluginBase implements AnalyzerInterface {

  /**
   * Creates an issue with title, summary, error level, and documentation
   * pulled from the plugin definition.
   *
   * @param TargetInterface $target
   *  The target module.
   *
   * @return IssueInterface
   */
  protected function buildIssue(TargetInterface $target) {
    $plugin_definition = $this->pluginDefinition;

    $issue = new Issue($target, $plugin_definition['message']);

    foreach ($plugin_definition['documentation'] as $doc) {
      $issue->addDocumentation($doc['url'], $doc['title']);
    }
    return $issue
      ->setSummary($plugin_definition['summary'])
      ->setErrorLevel($plugin_definition['level']);
  }

}
