<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Analyzer;

use Drupal\drupalmoduleupgrader\TranslationAwareDeriver;

/**
 * Builds derivative definitions for the _db plugin.
 */
class DBDeriver extends TranslationAwareDeriver {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_definition) {
    $derivatives = [];

    $functions = [
      'db_select', 'db_insert', 'db_update', 'db_merge', 'db_truncate',
    ];

    foreach ($functions as $function) {
      $derivative = $base_definition;
      $derivative['function'] = $function;
      $derivative['description'] = $this->translator
        ->translate('Checks for calls to @function() that refer to legacy tables.', [
          '@function' => $function,
        ]);
      $derivatives[$function] = $derivative;
    }

    return $derivatives;
  }

}
