<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Cleaner;

use Drupal\drupalmoduleupgrader\TranslationAwareDeriver;

/**
 * Builds derivative definitions for the _delete_hook plugin.
 */
class DeleteHookDeriver extends TranslationAwareDeriver {

  /**
   * {@inheritdoc}
   */
  public function getDerivativeDefinitions($base_definition) {
    $derivatives = [];

    $hooks = [
      'block_info', 'entity_info', 'exit', 'field_attach_create_bundle',
      'field_attach_delete_bundle', 'field_attach_rename_bundle',
      'field_formatter_info', 'field_widget_info', 'init', 'menu',
      'menu_alter', 'permission', 'url_outbound_alter', 'watchdog',
    ];

    foreach ($hooks as $hook) {
      $derivative = $base_definition;
      $derivative['hook'] = $hook;
      $derivative['description'] = $this->translator
        ->translate('Deletes implementations of hook_@hook().', [
          '@hook' => $hook,
        ]);
      $derivatives[$hook] = $derivative;
    }

    return $derivatives;
  }

}
