<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions;

use Drupal\drupalmoduleupgrader\TargetInterface;
use Pharborist\ClassMethodCallNode;
use Pharborist\Functions\FunctionCallNode;
use Pharborist\Parser;
use Pharborist\StringNode;

/**
 * @Converter(
 *  id = "l",
 *  description = @Translation("Rewrites calls to l().")
 * )
 */
class L extends URL {

  /**
   * {@inheritdoc}
   */
  public function rewrite(FunctionCallNode $call, TargetInterface $target) {
    $arguments = $call->getArguments();
    if ($arguments[1] instanceof StringNode) {
      // Create a call to url() and let the parent class rewrite it like normal,
      // so we don't have to duplicate that code.
      $url = Parser::parseSnippet('url(' . $arguments[1] . ');')->firstChild();

      return ClassMethodCallNode::create('\Drupal', 'l')
        ->appendArgument($arguments[0])
        ->appendArgument(parent::rewrite($url, $target));
    }
  }

}
