<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions;

use Drupal\drupalmoduleupgrader\TargetInterface;
use Pharborist\ClassMethodCallNode;
use Pharborist\Functions\FunctionCallNode;
use Pharborist\Node;
use Pharborist\Parser;

/**
 * @Converter(
 *  id = "language_url_split_prefix",
 *  description = @Translation("Rewrites calls to language_url_split_prefix().")
 * )
 */
class LanguageURLSplitPrefix extends FunctionCallModifier {

  /**
   * {@inheritdoc}
   */
  public function rewrite(FunctionCallNode $call, TargetInterface $target) {
    return ClassMethodCallNode::create('\Drupal', 'service')
      ->appendArgument(Node::fromValue('plugin.manager.language_negotiation_method'))
      ->appendMethodCall('createInstance')
      ->appendArgument('language-url')
      ->appendMethodCall('processInbound')
      ->appendArgument(Parser::parseSnippet('current_path()')->firstChild())
      ->appendArgument(ClassMethodCallNode::create('\Drupal', 'request'));
  }

}
