<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions;

use Drupal\drupalmoduleupgrader\TargetInterface;
use Pharborist\ClassMethodCallNode;
use Pharborist\Functions\FunctionCallNode;
use Pharborist\Node;

/**
 * @Converter(
 *  id = "variable_del",
 *  description = @Translation("Replaces variable_del() calls with Configuration API.")
 * )
 */
class VariableDel extends FunctionCallModifier {

  /**
   * {@inheritdoc}
   */
  public function rewrite(FunctionCallNode $call, TargetInterface $target) {
    return ClassMethodCallNode::create('\Drupal', 'config')
      ->appendArgument(Node::fromValue($target->id() . '.settings'))
      ->appendMethodCall('clear')
      ->appendArgument(clone $call->getArgumentList()->getItem(0));
  }

}
