<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Converter\Functions;

use Drupal\drupalmoduleupgrader\TargetInterface;
use Pharborist\ClassMethodCallNode;
use Pharborist\Functions\FunctionCallNode;
use Pharborist\Node;

/**
 * @Converter(
 *  id = "variable_set",
 *  description = @Translation("Replaces variable_set() calls with Configuration API.")
 * )
 */
class VariableSet extends FunctionCallModifier {

  /**
   * {@inheritdoc}
   */
  public function rewrite(FunctionCallNode $call, TargetInterface $target) {
    $arguments = $call->getArguments();

    return ClassMethodCallNode::create('\Drupal', 'config')
      ->appendArgument(Node::fromValue($target->id() . '.settings'))
      ->appendMethodCall('set')
      ->appendArgument(clone $arguments[0])
      ->appendArgument(clone $arguments[1])
      ->appendMethodCall('save');
  }

}
