<?php

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Converter;

use Drupal\drupalmoduleupgrader\ConverterBase;
use Drupal\drupalmoduleupgrader\TargetInterface;

/**
 * @Converter(
 *  id = "hook_field_attach_create_bundle",
 *  description = @Translation("Renames hook_field_attach_create_bundle()."),
 *  hook = "field_attach_create_bundle"
 * )
 */
class HookFieldAttachCreateBundle extends ConverterBase {

  /**
   * {@inheritdoc}
   */
  public function convert(TargetInterface $target) {
    $indexer = $target->getIndexer('hook');

    if ($indexer->has($this->pluginDefinition['hook'])) {
      $hook = $indexer
        ->get($this->pluginDefinition['hook'])
        ->get(0)
        ->setName($target->id() . '_entity_bundle_create');

      $target->getCodeManager()->save($hook);
    }
  }

}
