<?php

namespace Drupal\drupalmoduleupgrader;

use Drupal\Core\Plugin\Discovery\ContainerDeriverInterface;
use Drupal\Core\StringTranslation\TranslationInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

abstract class TranslationAwareDeriver extends DeriverBase implements ContainerDeriverInterface {

  /**
   * @var \Drupal\Core\StringTranslation\TranslationInterface
   */
  protected $translator;

  public function __construct(TranslationInterface $translator) {
    $this->translator = $translator;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, $base_plugin_id) {
    return new static($container->get('string_translation'));
  }

}
