<?php

/**
 * @file
 * Contains \Drupal\drupalmoduleupgrader\Utility\Filter\NodeAssignmentFilter.
 */

namespace Drupal\drupalmoduleupgrader\Utility\Filter;

use Pharborist\Filter;
use Pharborist\Node;
use Pharborist\Operator\AssignNode;
use Pharborist\VariableNode;

class NodeAssignmentFilter {

  /**
   * Tests if the given node is on the left side of an assignment.
   *
   * @param \Pharborist\Node $node
   *  The node to test.
   *
   * @return boolean
   */
  public function __invoke(Node $node) {
    $assignment = $node->closest(Filter::isInstanceOf('\Pharborist\Operator\AssignNode'));
    return ($assignment ? $assignment->getLeftOperand() === $node : FALSE);
  }

}
