<?php

namespace Drupal\Tests\drupalmoduleupgrader\Unit\Plugin\DMU\FunctionReplacement;

use Drupal\drupalmoduleupgrader\Plugin\DMU\FunctionReplacement\DrupalWriteRecord;
use Drupal\Tests\UnitTestCase;
use Pharborist\Parser;

/**
 * @group DMU
 */
class DrupalWriteRecordTest extends UnitTestCase {

  public function testRewrite() {
    $plugin = new DrupalWriteRecord([], 'DrupalWriteRecord', []);

    $call = Parser::parseSnippet('drupal_write_record("foobar", $record);')->firstChild();
    $this->assertEquals('\Drupal::database()->insert("foobar")->fields($record)->execute()', $plugin->rewrite($call)->getText());

    $call = Parser::parseSnippet('drupal_write_record("foobar", $record, array("id"));')->firstChild();
    $this->assertEquals('\Drupal::database()->merge("foobar")->fields($record)->key(array("id"))->execute()', $plugin->rewrite($call)->getText());

    $call = Parser::parseSnippet('drupal_write_record("foobar", $record, "baz");')->firstChild();
    $this->assertEquals('\Drupal::database()->merge("foobar")->fields($record)->key(["baz"])->execute()', $plugin->rewrite($call)->getText());
  }

}
