<?php

namespace Drupal\Tests\drupalmoduleupgrader\Unit\Plugin\DMU\FunctionReplacement;

use Drupal\drupalmoduleupgrader\Plugin\DMU\FunctionReplacement\FieldViewField;
use Drupal\Tests\UnitTestCase;
use Pharborist\Parser;

/**
 * @group DMU
 */
class FieldViewFieldTest extends UnitTestCase {

  public function testRewrite() {
    $plugin = new FieldViewField([], 'FieldViewField', []);

    $call = Parser::parseSnippet('field_view_field("node", $node, "field_foo", $view_mode, $langcode);')->firstChild();
    $this->assertEquals('$node->field_foo->view($view_mode)', $plugin->rewrite($call)->getText());

    $call = Parser::parseSnippet('field_view_field("node", $node, "field_foo", array("type" => "some_formatter"), $langcode);')->firstChild();
    $this->assertEquals('$node->field_foo->view(array("type" => "some_formatter"))', $plugin->rewrite($call)->getText());
  }

}
