<?php

namespace Drupal\Tests\drupalmoduleupgrader\Unit\Plugin\DMU\FunctionReplacement;

use Drupal\drupalmoduleupgrader\Plugin\DMU\FunctionReplacement\FieldViewValue;
use Drupal\Tests\UnitTestCase;
use Pharborist\Parser;

/**
 * @group DMU
 */
class FieldViewValueTest extends UnitTestCase {

  public function testRewrite() {
    $plugin = new FieldViewValue([], 'FieldViewValue', []);

    $call = Parser::parseSnippet('field_view_value("node", $node, "field_foo", $item, $view_mode, $langcode);')->firstChild();
    $this->assertEquals('$item->view($view_mode)', $plugin->rewrite($call)->getText());

    $call = Parser::parseSnippet('field_view_value("node", $node, "field_foo", $item, array("type" => "some_formatter"), $langcode);')->firstChild();
    $this->assertEquals('$item->view(array("type" => "some_formatter"))', $plugin->rewrite($call)->getText());
  }

}
